"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _react = _interopRequireDefault(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _dualListSelect = _interopRequireDefault(require("@data-driven-forms/common/dual-list-select"));

var _clsx = _interopRequireDefault(require("clsx"));

var _reactJssCjs = require("react-jss/dist/react-jss.cjs.js");

var _Grid = _interopRequireDefault(require("carbon-components-react/lib/components/Grid/Grid.js"));

var _Row = _interopRequireDefault(require("carbon-components-react/lib/components/Grid/Row.js"));

var _Column = _interopRequireDefault(require("carbon-components-react/lib/components/Grid/Column.js"));

var _Button = _interopRequireDefault(require("carbon-components-react/lib/components/Button/Button.js"));

var _FormGroup = _interopRequireDefault(require("carbon-components-react/lib/components/FormGroup/FormGroup.js"));

var _Search = _interopRequireDefault(require("carbon-components-react/lib/components/Search/Search.js"));

var _TooltipIcon = _interopRequireDefault(require("carbon-components-react/lib/components/TooltipIcon/TooltipIcon.js"));

var _ = _interopRequireDefault(require("@carbon/icons-react/lib/checkmark--filled/16.js"));

var _2 = _interopRequireDefault(require("@carbon/icons-react/lib/chevron--right/32.js"));

var _3 = _interopRequireDefault(require("@carbon/icons-react/lib/chevron--left/32.js"));

var _4 = _interopRequireDefault(require("@carbon/icons-react/lib/caret--sort--down/32.js"));

var _5 = _interopRequireDefault(require("@carbon/icons-react/lib/caret--sort--up/32.js"));

var _StructuredList = require("carbon-components-react/lib/components/StructuredList/StructuredList.js");

var _prepareProps = require("../prepare-props");

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { (0, _defineProperty2["default"])(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }

var useStyles = (0, _reactJssCjs.createUseStyles)({
  dualList: {
    maxHeight: 500,
    overflow: 'auto',
    display: 'block',
    marginBottom: 0
  },
  dualListBody: {
    width: '100%',
    display: 'inline-table'
  },
  buttonWrapper: {
    flexDirection: 'column',
    padding: '8px !important',
    paddingTop: '8px !important',
    button: {
      width: '100%',
      maxWidth: '100%',
      '@media (max-width: 1055px)': {
        svg: {
          transform: 'rotate(90deg)'
        }
      }
    },
    '& button:not(:last-child)': {
      marginBottom: 8
    }
  },
  toolbar: {
    display: 'flex'
  },
  tooltipButton: {
    background: '#c2c1c1 !important'
  }
});

var EmptyList = function EmptyList(_ref) {
  var message = _ref.message;
  return /*#__PURE__*/_react["default"].createElement(_StructuredList.StructuredListWrapper, null, /*#__PURE__*/_react["default"].createElement(_StructuredList.StructuredListBody, null, /*#__PURE__*/_react["default"].createElement(_StructuredList.StructuredListRow, null, /*#__PURE__*/_react["default"].createElement(_StructuredList.StructuredListCell, null, message))));
};

EmptyList.propTypes = {
  message: _propTypes["default"].string
};

var List = function List(_ref2) {
  var options = _ref2.options,
      selectedValues = _ref2.selectedValues,
      handleOptionsClick = _ref2.handleOptionsClick,
      noTitle = _ref2.noTitle,
      ListProps = _ref2.ListProps,
      BodyProps = _ref2.BodyProps;

  var _useStyles = useStyles(),
      dualList = _useStyles.dualList,
      dualListBody = _useStyles.dualListBody;

  return options.length > 0 ? /*#__PURE__*/_react["default"].createElement(_StructuredList.StructuredListWrapper, (0, _extends2["default"])({
    selection: true
  }, ListProps, {
    className: (0, _clsx["default"])(dualList, ListProps.className)
  }), /*#__PURE__*/_react["default"].createElement(_StructuredList.StructuredListBody, (0, _extends2["default"])({}, BodyProps, {
    className: (0, _clsx["default"])(dualListBody, BodyProps.className)
  }), options.map(function (_ref3) {
    var value = _ref3.value,
        label = _ref3.label,
        ListRowProps = _ref3.ListRowProps,
        ListCellProps = _ref3.ListCellProps,
        GridProps = _ref3.GridProps,
        RowProps = _ref3.RowProps,
        LabelProps = _ref3.LabelProps,
        CheckmarkProps = _ref3.CheckmarkProps;
    return /*#__PURE__*/_react["default"].createElement(_StructuredList.StructuredListRow, (0, _extends2["default"])({
      key: value
    }, ListRowProps, {
      onClick: function onClick(e) {
        return handleOptionsClick(_objectSpread(_objectSpread({}, e), {}, {
          ctrlKey: true
        }), value);
      }
    }), /*#__PURE__*/_react["default"].createElement(_StructuredList.StructuredListCell, ListCellProps, /*#__PURE__*/_react["default"].createElement(_Grid["default"], GridProps, /*#__PURE__*/_react["default"].createElement(_Row["default"], (0, _extends2["default"])({
      narrow: true
    }, RowProps), /*#__PURE__*/_react["default"].createElement(_Column["default"], (0, _extends2["default"])({
      sm: 3
    }, LabelProps), label), /*#__PURE__*/_react["default"].createElement(_Column["default"], (0, _extends2["default"])({
      sm: 1
    }, CheckmarkProps), selectedValues.includes(value) && /*#__PURE__*/_react["default"].createElement(_["default"], null))))));
  }))) : /*#__PURE__*/_react["default"].createElement(EmptyList, {
    message: noTitle
  });
};

List.propTypes = {
  options: _propTypes["default"].array,
  selectedValues: _propTypes["default"].array,
  handleOptionsClick: _propTypes["default"].func,
  noTitle: _propTypes["default"].node,
  ListProps: _propTypes["default"].object,
  BodyProps: _propTypes["default"].object
};

var Toolbar = function Toolbar(_ref4) {
  var sortTitle = _ref4.sortTitle,
      onFilter = _ref4.onFilter,
      onSort = _ref4.onSort,
      sortDirection = _ref4.sortDirection,
      placeholder = _ref4.placeholder,
      ToolbarProps = _ref4.ToolbarProps,
      SearchProps = _ref4.SearchProps,
      SortProps = _ref4.SortProps;

  var _useStyles2 = useStyles(),
      toolbar = _useStyles2.toolbar,
      tooltipButton = _useStyles2.tooltipButton;

  return /*#__PURE__*/_react["default"].createElement("div", (0, _extends2["default"])({}, ToolbarProps, {
    className: (0, _clsx["default"])(toolbar, ToolbarProps.className)
  }), /*#__PURE__*/_react["default"].createElement(_Search["default"], (0, _extends2["default"])({
    onChange: function onChange(e) {
      return onFilter(e.target.value);
    },
    labelText: "",
    placeholder: placeholder
  }, SearchProps)), /*#__PURE__*/_react["default"].createElement(_TooltipIcon["default"], (0, _extends2["default"])({
    onClick: onSort,
    tooltipText: sortTitle
  }, SortProps, {
    className: (0, _clsx["default"])(tooltipButton, SortProps.className)
  }), sortDirection ? /*#__PURE__*/_react["default"].createElement(_4["default"], null) : /*#__PURE__*/_react["default"].createElement(_5["default"], null)));
};

Toolbar.propTypes = {
  sortTitle: _propTypes["default"].string,
  onFilter: _propTypes["default"].func,
  onSort: _propTypes["default"].func,
  sortDirection: _propTypes["default"].bool,
  placeholder: _propTypes["default"].string,
  ToolbarProps: _propTypes["default"].object,
  SearchProps: _propTypes["default"].object,
  SortProps: _propTypes["default"].object
};

var isEmpty = function isEmpty(array) {
  return array.length === 0;
};

var DualListSelectInner = function DualListSelectInner(_ref5) {
  var leftValues = _ref5.leftValues,
      handleOptionsClick = _ref5.handleOptionsClick,
      rightValues = _ref5.rightValues,
      handleValuesClick = _ref5.handleValuesClick,
      handleMoveRight = _ref5.handleMoveRight,
      handleClearLeftValues = _ref5.handleClearLeftValues,
      handleMoveLeft = _ref5.handleMoveLeft,
      handleClearRightValues = _ref5.handleClearRightValues,
      state = _ref5.state,
      filterOptions = _ref5.filterOptions,
      filterValues = _ref5.filterValues,
      sortOptions = _ref5.sortOptions,
      sortValues = _ref5.sortValues,
      noOptionsTitle = _ref5.noOptionsTitle,
      noValueTitle = _ref5.noValueTitle,
      leftTitle = _ref5.leftTitle,
      rightTitle = _ref5.rightTitle,
      LeftTitleElement = _ref5.LeftTitleElement,
      RightTitleElement = _ref5.RightTitleElement,
      LeftTitleProps = _ref5.LeftTitleProps,
      RightTitleProps = _ref5.RightTitleProps,
      moveLeftTitle = _ref5.moveLeftTitle,
      moveRightTitle = _ref5.moveRightTitle,
      moveAllLeftTitle = _ref5.moveAllLeftTitle,
      moveAllRightTitle = _ref5.moveAllRightTitle,
      label = _ref5.label,
      isRequired = _ref5.isRequired,
      filterOptionsTitle = _ref5.filterOptionsTitle,
      filterValuesTitle = _ref5.filterValuesTitle,
      sortOptionsTitle = _ref5.sortOptionsTitle,
      sortValuesTitle = _ref5.sortValuesTitle,
      filterOptionsText = _ref5.filterOptionsText,
      filterValueText = _ref5.filterValueText,
      FormGroupProps = _ref5.FormGroupProps,
      GridProps = _ref5.GridProps,
      RowProps = _ref5.RowProps,
      OptionsColumnProps = _ref5.OptionsColumnProps,
      ButtonColumnProps = _ref5.ButtonColumnProps,
      ValuesColumnProps = _ref5.ValuesColumnProps,
      AddButtonProps = _ref5.AddButtonProps,
      AddAllButtonProps = _ref5.AddAllButtonProps,
      RemoveButtonProps = _ref5.RemoveButtonProps,
      RemoveAllButtonProps = _ref5.RemoveAllButtonProps,
      LeftToolbarProps = _ref5.LeftToolbarProps,
      RightToolbarProps = _ref5.RightToolbarProps,
      LeftSearchProps = _ref5.LeftSearchProps,
      RightSearchProps = _ref5.RightSearchProps,
      LeftSortProps = _ref5.LeftSortProps,
      RightSortProps = _ref5.RightSortProps,
      LeftListProps = _ref5.LeftListProps,
      LeftBodyProps = _ref5.LeftBodyProps,
      RightListProps = _ref5.RightListProps,
      RightBodyProps = _ref5.RightBodyProps;

  var _useStyles3 = useStyles(),
      buttonWrapper = _useStyles3.buttonWrapper;

  return /*#__PURE__*/_react["default"].createElement(_FormGroup["default"], (0, _extends2["default"])({
    legendText: (0, _prepareProps.buildLabel)(label || '', isRequired)
  }, FormGroupProps), /*#__PURE__*/_react["default"].createElement(_Grid["default"], GridProps, /*#__PURE__*/_react["default"].createElement(_Row["default"], (0, _extends2["default"])({
    condensed: true
  }, RowProps), /*#__PURE__*/_react["default"].createElement(_Column["default"], (0, _extends2["default"])({
    sm: 4,
    md: 8,
    lg: 5
  }, OptionsColumnProps), /*#__PURE__*/_react["default"].createElement(LeftTitleElement, LeftTitleProps, leftTitle), /*#__PURE__*/_react["default"].createElement(Toolbar, {
    onFilter: filterOptions,
    placeholder: filterOptionsTitle,
    sortDirection: state.sortLeftDesc,
    onSort: sortOptions,
    sortTitle: sortOptionsTitle,
    ToolbarProps: LeftToolbarProps,
    SearchProps: LeftSearchProps,
    SortProps: LeftSortProps
  }), /*#__PURE__*/_react["default"].createElement(List, {
    ListProps: LeftListProps,
    BodyProps: LeftBodyProps,
    options: leftValues,
    selectedValues: state.selectedLeftValues,
    handleOptionsClick: handleOptionsClick,
    noTitle: state.filterOptions ? filterOptionsText : noOptionsTitle
  })), /*#__PURE__*/_react["default"].createElement(_Column["default"], (0, _extends2["default"])({
    sm: 4,
    md: 8,
    lg: 2
  }, ButtonColumnProps, {
    className: (0, _clsx["default"])(buttonWrapper, ButtonColumnProps.className)
  }), /*#__PURE__*/_react["default"].createElement(_Button["default"], (0, _extends2["default"])({
    id: "move-right",
    renderIcon: _2["default"],
    onClick: handleMoveRight,
    disabled: isEmpty(state.selectedLeftValues)
  }, AddButtonProps), moveRightTitle), /*#__PURE__*/_react["default"].createElement(_Button["default"], (0, _extends2["default"])({
    id: "move-all-right",
    onClick: handleClearLeftValues,
    disabled: isEmpty(leftValues)
  }, AddAllButtonProps), moveAllRightTitle), /*#__PURE__*/_react["default"].createElement(_Button["default"], (0, _extends2["default"])({
    id: "move-all-left",
    onClick: handleClearRightValues,
    disabled: isEmpty(rightValues)
  }, RemoveAllButtonProps), moveAllLeftTitle), /*#__PURE__*/_react["default"].createElement(_Button["default"], (0, _extends2["default"])({
    id: "move-left",
    renderIcon: _3["default"],
    onClick: handleMoveLeft,
    disabled: isEmpty(state.selectedRightValues)
  }, RemoveButtonProps), moveLeftTitle)), /*#__PURE__*/_react["default"].createElement(_Column["default"], (0, _extends2["default"])({
    sm: 4,
    md: 8,
    lg: 5
  }, ValuesColumnProps), /*#__PURE__*/_react["default"].createElement(RightTitleElement, RightTitleProps, rightTitle), /*#__PURE__*/_react["default"].createElement(Toolbar, {
    onFilter: filterValues,
    placeholder: filterValuesTitle,
    sortDirection: state.sortRightDesc,
    onSort: sortValues,
    sortTitle: sortValuesTitle,
    ToolbarProps: RightToolbarProps,
    SearchProps: RightSearchProps,
    SortProps: RightSortProps
  }), /*#__PURE__*/_react["default"].createElement(List, {
    ListProps: RightListProps,
    BodyProps: RightBodyProps,
    options: rightValues,
    selectedValues: state.selectedRightValues,
    handleOptionsClick: handleValuesClick,
    noTitle: state.filterValue ? filterValueText : noValueTitle
  })))));
};

DualListSelectInner.propTypes = {
  leftValues: _propTypes["default"].array,
  handleOptionsClick: _propTypes["default"].func,
  rightValues: _propTypes["default"].array,
  handleValuesClick: _propTypes["default"].func,
  handleMoveRight: _propTypes["default"].func,
  handleClearLeftValues: _propTypes["default"].func,
  handleMoveLeft: _propTypes["default"].func,
  handleClearRightValues: _propTypes["default"].func,
  state: _propTypes["default"].object,
  filterOptions: _propTypes["default"].func,
  filterValues: _propTypes["default"].func,
  sortValues: _propTypes["default"].func,
  sortOptions: _propTypes["default"].func,
  noOptionsTitle: _propTypes["default"].node,
  noValueTitle: _propTypes["default"].node,
  leftTitle: _propTypes["default"].node,
  rightTitle: _propTypes["default"].node,
  LeftTitleElement: _propTypes["default"].string,
  RightTitleElement: _propTypes["default"].string,
  LeftTitleProps: _propTypes["default"].object,
  RightTitleProps: _propTypes["default"].object,
  moveLeftTitle: _propTypes["default"].node,
  moveRightTitle: _propTypes["default"].node,
  moveAllLeftTitle: _propTypes["default"].node,
  moveAllRightTitle: _propTypes["default"].node,
  label: _propTypes["default"].node,
  isRequired: _propTypes["default"].bool,
  filterOptionsTitle: _propTypes["default"].string,
  filterValuesTitle: _propTypes["default"].string,
  sortOptionsTitle: _propTypes["default"].string,
  sortValuesTitle: _propTypes["default"].string,
  filterOptionsText: _propTypes["default"].node,
  filterValueText: _propTypes["default"].node,
  FormGroupProps: _propTypes["default"].object,
  GridProps: _propTypes["default"].object,
  RowProps: _propTypes["default"].object,
  OptionsColumnProps: _propTypes["default"].object,
  ButtonColumnProps: _propTypes["default"].object,
  ValuesColumnProps: _propTypes["default"].object,
  AddButtonProps: _propTypes["default"].object,
  AddAllButtonProps: _propTypes["default"].object,
  RemoveButtonProps: _propTypes["default"].object,
  RemoveAllButtonProps: _propTypes["default"].object,
  LeftToolbarProps: _propTypes["default"].object,
  RightToolbarProps: _propTypes["default"].object,
  LeftSearchProps: _propTypes["default"].object,
  RightSearchProps: _propTypes["default"].object,
  LeftSortProps: _propTypes["default"].object,
  RightSortProps: _propTypes["default"].object,
  LeftListProps: _propTypes["default"].object,
  LeftBodyProps: _propTypes["default"].object,
  RightListProps: _propTypes["default"].object,
  RightBodyProps: _propTypes["default"].object
};
DualListSelectInner.defaultProps = {
  noOptionsTitle: 'No option available',
  noValueTitle: 'No option selected',
  leftTitle: 'Options',
  rightTitle: 'Selected',
  LeftTitleElement: 'h6',
  RightTitleElement: 'h6',
  moveLeftTitle: 'Remove',
  moveRightTitle: 'Add',
  moveAllLeftTitle: 'Remove All',
  moveAllRightTitle: 'Add All',
  filterOptionsTitle: 'Filter options',
  filterValuesTitle: 'Filter values',
  sortOptionsTitle: 'Sort options',
  sortValuesTitle: 'Sort values',
  filterOptionsText: 'Remove your filter to see all options',
  filterValueText: 'Remove your filter to see all selected',
  FormGroupProps: {},
  GridProps: {},
  RowProps: {},
  OptionsColumnProps: {},
  ButtonColumnProps: {},
  ValuesColumnProps: {},
  AddButtonProps: {},
  AddAllButtonProps: {},
  RemoveButtonProps: {},
  RemoveAllButtonProps: {},
  LeftToolbarProps: {},
  RightToolbarProps: {},
  LeftSearchProps: {},
  RightSearchProps: {},
  LeftSortProps: {},
  RightSortProps: {},
  LeftListProps: {},
  LeftBodyProps: {},
  RightListProps: {},
  RightBodyProps: {}
};

var DualListSelect = function DualListSelect(props) {
  return /*#__PURE__*/_react["default"].createElement(_dualListSelect["default"], (0, _extends2["default"])({}, props, {
    DualListSelect: DualListSelectInner
  }));
};

var _default = DualListSelect;
exports["default"] = _default;