"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));

var _react = _interopRequireDefault(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _clsx = _interopRequireDefault(require("clsx"));

var _reactJssCjs = require("react-jss/dist/react-jss.cjs.js");

var _Tabs = _interopRequireDefault(require("carbon-components-react/lib/components/Tabs/Tabs.js"));

var _Tab = _interopRequireDefault(require("carbon-components-react/lib/components/Tab/Tab.js"));

var _useFormApi = _interopRequireDefault(require("@data-driven-forms/react-form-renderer/use-form-api"));

var _excluded = ["fields", "component", "name", "TabWrapperProps"],
    _excluded2 = ["fields", "name", "label", "title"];
var useStyles = (0, _reactJssCjs.createUseStyles)({
  tab: {
    '&>:not(:last-child)': {
      marginBottom: 32
    }
  }
});

var Tabs = function Tabs(_ref) {
  var fields = _ref.fields,
      component = _ref.component,
      name = _ref.name,
      TabWrapperProps = _ref.TabWrapperProps,
      props = (0, _objectWithoutProperties2["default"])(_ref, _excluded);
  var formOptions = (0, _useFormApi["default"])();

  var _useStyles = useStyles(),
      tab = _useStyles.tab;

  return /*#__PURE__*/_react["default"].createElement(_Tabs["default"], props, fields.map(function (_ref2) {
    var fields = _ref2.fields,
        name = _ref2.name,
        label = _ref2.label,
        title = _ref2.title,
        rest = (0, _objectWithoutProperties2["default"])(_ref2, _excluded2);
    return /*#__PURE__*/_react["default"].createElement(_Tab["default"], (0, _extends2["default"])({}, rest, {
      id: name,
      key: name,
      label: label || title
    }), /*#__PURE__*/_react["default"].createElement("div", (0, _extends2["default"])({}, TabWrapperProps, {
      className: (0, _clsx["default"])(tab, TabWrapperProps.className)
    }), formOptions.renderForm(fields, formOptions)));
  }));
};

Tabs.propTypes = {
  TabWrapperProps: _propTypes["default"].object,
  component: _propTypes["default"].string,
  name: _propTypes["default"].string,
  fields: _propTypes["default"].arrayOf(_propTypes["default"].shape({
    name: _propTypes["default"].string,
    fields: _propTypes["default"].array,
    title: _propTypes["default"].node,
    label: _propTypes["default"].node
  }))
};
Tabs.defaultProps = {
  TabWrapperProps: {}
};
var _default = Tabs;
exports["default"] = _default;